//////////////////////////////////////////////////////////////////////////////////
// :   
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 05.2001
//////////////////////////////////////////////////////////////////////////////////
#include "rm.h"
#include "enumerate.h"
#include "scene.h"
#include <stdio.h>
#include <time.h>
#include <mmsystem.h>


static D3DVECTOR dir_begin, up_begin;

//  
void SetCamera()
{
		rm_info.camera->SetPosition(rm_info.scene,D3DVALUE(0),D3DVALUE(0),D3DVALUE(-50));
		rm_info.camera->LookAt(rm_info.scene,NULL, D3DRMCONSTRAIN_Z );
		rm_info.camera->GetOrientation(rm_info.scene, &dir_begin, &up_begin);
		rm_info.viewport->SetBack(D3DVAL(10000));
		rm_info.scene->SetSceneBackground(RGB_MAKE(32,24,32));
}

void move_camera()
{
	// 
	if ( rm_info.delta_x || rm_info.delta_y )
	{
		D3DVECTOR dir, up;
		D3DRMVECTOR4D v_trans;

		rm_info.camera->GetOrientation(rm_info.scene, &dir, &up);
		rm_info.viewport->Transform(&v_trans, &dir);
		v_trans.x+=rm_info.delta_x; rm_info.delta_x=0;
		v_trans.y+=rm_info.delta_y; rm_info.delta_y=0;
		rm_info.viewport->InverseTransform(&dir, &v_trans);
		rm_info.camera->SetOrientation(rm_info.scene,
			dir.x, dir.y, dir.z,
			up_begin.x, up_begin.y, up_begin.z );
	}

	// 
	D3DVALUE delta_x=D3DVAL(0), delta_z=D3DVAL(0), delta_y=D3DVAL(0);

	if ( rm_info.keys[VK_UP]==TRUE ) delta_z=D3DVAL(1);
	if ( rm_info.keys[VK_DOWN]==TRUE ) delta_z=D3DVAL(-1);
	if ( rm_info.keys['Q']==TRUE ) delta_y=D3DVAL(1);
	if ( rm_info.keys['A']==TRUE ) delta_y=D3DVAL(-1);
	if ( rm_info.keys[VK_RIGHT]==TRUE ) delta_x=D3DVAL(1);
	if ( rm_info.keys[VK_LEFT]==TRUE ) delta_x=D3DVAL(-1);
	if ( rm_info.keys[VK_SHIFT]==TRUE ) { delta_x*=D3DVAL(2); delta_y*=D3DVAL(2); }

	rm_info.camera->AddTranslation(D3DRMCOMBINE_BEFORE, delta_x, delta_y, delta_z );
	
	//  
	if ( rm_info.keys['R']==TRUE )
	{
		rm_info.camera->SetPosition(rm_info.scene,D3DVALUE(0),D3DVALUE(0),D3DVALUE(-50));
		rm_info.camera->LookAt(rm_info.scene,NULL, D3DRMCONSTRAIN_Z );
	}

	if ( rm_info.keys['1']==TRUE && n_scene!=0 ) { DestroyScene(); n_scene=0; CreateScene(); }
	if ( rm_info.keys['2']==TRUE && n_scene!=1  ) { DestroyScene(); n_scene=1; CreateScene(); }
	if ( rm_info.keys['3']==TRUE && n_scene!=2  ) { DestroyScene(); n_scene=2; CreateScene(); }
	if ( rm_info.keys['4']==TRUE && n_scene!=3 ) { DestroyScene(); n_scene=3; CreateScene(); }
}
