typedef struct
{
    //DWORD     dwType;
    D3DVECTOR dvPosition;
    //D3DVECTOR dvNormal;
    //D3DCOLOR  dcColor;
    //D3DVALUE  tu;
    //D3DVALUE  tv;
} VertexTriangle_t;

VertexTriangle_t v_tri[] ={
	{	//D3DRMVERTEX_LIST,
		{ 1.0f,  1.0f, -1.0f, },
		//{ 0.0f,  0.0f, -1.0f, },
		RGB_MAKE(0,0,255),
		//0.0f, 0.0f,
	},
	{	//D3DRMVERTEX_LIST,
		{ 1.0f, -1.0f, -1.0f, },
		//{ 0.0f,  0.0f, -1.0f, },
		RGB_MAKE(0,0,255),
		//0.0f, 0.0f,
	},
	{	//D3DRMVERTEX_LIST,
		{ -1.0f, -1.0f, -1.0f, },
		//{  0.0f,  0.0f, -1.0f, },
		RGB_MAKE(0,0,255),
		//0.0f, 0.0f,
	},
};

//    
BOOL build_cube_tri( LPDIRECT3DRMMESHBUILDER3 mb, float angle )
{

	//  
    mb->AddTriangles( 0, D3DRMFVF_COLOR, // | D3DRMFVF_TYPE | D3DRMFVF_NORMAL | D3DRMFVF_TEXTURECOORDS,
		3, (LPVOID) &v_tri );
	//  
	mb->GenerateNormals(angle,
		D3DRMGENERATENORMALS_USECREASEANGLE );
/*	mb->SetColorSource(D3DRMCOLOR_FROMVERTEX);
	LPDIRECT3DRMMATERIAL2 mat=0;
	rm_info.rm->CreateMaterial(D3DVAL(5.0), &mat);
	mb->SetMaterial(mat);
	DD_RELEASE( mat );*/
	return TRUE;

}

//	mb->SetColorSource(D3DRMCOLOR_FROMVERTEX);
//	for ( i=0; i<16; i++ )
//		mb->SetVertexColor(i,colors[i]);


// 
void material_cube( LPDIRECT3DRMMESHBUILDER3 mb )
{
	int i;
	LPDIRECT3DRMFACE2 face=0;
	LPDIRECT3DRMMATERIAL2 mat=0;

    // Create a material, setting the reflectiveness (5.0 is metallic, 
    // higher is more plastic) on the previously loaded mesh.
    rm_info.rm->CreateMaterial(D3DVAL(5.0), &mat);
	mat->SetSpecular(D3DVAL(1),D3DVAL(1),D3DVAL(1));
	mb->SetMaterial(mat);
	//mat->SetEmissive(D3DVAL(0.1),D3DVAL(0.1),D3DVAL(0.1));
	//mat->SetAmbient(D3DVAL(0),D3DVAL(0),D3DVAL(0.1));

/*	for ( i=0; i<6; i++ )
	{
		if ( GetFace(mb,i,&face)==FALSE ) break;
		face->SetMaterial(mat);
		DD_RELEASE( face );
	}*/
	DD_RELEASE( mat );
}


	//  +  
	// 
	rc=rm_info.rm->CreateFrame( main_frame, &frame );
	DD_CHK(rc,_gError);
	// 
	frame->SetPosition( main_frame, 0.0f, 0.0f, 0.0f );
	//  
	mesh_builder->Clone(0, IID_IDirect3DRMVisual, (LPVOID *)&clone_mesh);
	// 
	color_cube(clone_mesh);
	// 
	frame->AddVisual( (LPDIRECT3DRMVISUAL)clone_mesh );
	DD_RELEASE( clone_mesh );
	DD_RELEASE( frame );


LPDIRECT3DRMANIMATIONSET2  anim_set=0;
LPDIRECT3DRMFRAME3 meshframe=0;
D3DVALUE anim_time=0;

static void __cdecl anim_callback
	(LPDIRECT3DRMFRAME3 obj, LPVOID arg, D3DVALUE delta)
{
    anim_set->SetTime(anim_time);
    anim_time += delta;
}


//    
BOOL DemoAnimModel()
{
	HRESULT rc;

	DeleteNamesFrame(meshframe);
	DD_RELEASE( meshframe );

	rm_info.rm->CreateFrame(main_frame,&meshframe);
	meshframe->SetPosition(main_frame,D3DVAL(0.),D3DVAL(5.),D3DVAL(0.));
	meshframe->SetOrientation(main_frame,
			D3DVAL(0),D3DVAL(0),D3DVAL(-1),
			D3DVAL(0),D3DVAL(1),D3DVAL(0) );

	DD_RELEASE( anim_set );
	rm_info.rm->CreateAnimationSet(&anim_set);
	rc = anim_set->Load((LPVOID)"med_girl.x",NULL,D3DRMLOAD_FROMFILE,NULL,NULL,meshframe);
	DD_CHK(rc,_gError);
	meshframe->AddMoveCallback(anim_callback, (LPVOID)NULL, D3DRMCALLBACK_PREORDER);
	anim_time=0;

	ScaleFrame(meshframe,20);

	return TRUE;

_gError:
	DD_RELEASE( meshframe );
	DD_RELEASE( anim_set );
	return FALSE;
}

	case 4: if ( DemoAnimModel()==FALSE ) return FALSE; break;
