//////////////////////////////////////////////////////////////////////////////////
// : RM
// :   DD  D3D
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 05.2001
//////////////////////////////////////////////////////////////////////////////////
#ifndef ENUMERATE_H
#define ENUMERATE_H

#include <windows.h>
#include <windowsx.h>
#include <d3d.h>

#define MAX_NAME_DRV 50
#define MAX_DRV_DD 10
#define MAX_DRV_D3D 30
#define MAX_MODE_DD 200

//  
typedef struct {
	DDSURFACEDESC desc;
	DWORD width;
	DWORD height;
	DWORD bpp;
	char about[MAX_NAME_DRV];
} Mode_Info_t;

//   DD
typedef struct {
	GUID	Guid;
	char	Name[MAX_NAME_DRV];
	char	Desc[MAX_NAME_DRV];
	DDCAPS	HALCaps;
	DDCAPS	HELCaps;
} Drv_DD_Info_t;

//   D3D
typedef struct {
	int		n_dd; //   DD
	
	GUID	Guid;
	char	Name[MAX_NAME_DRV];
	char	About[MAX_NAME_DRV*2];
	D3DDEVICEDESC	Desc;

	BOOL	isHardware; //  
	BOOL	isTexture;
	BOOL	isZbuffer;
	BOOL	isRGB;

	//  ,   
	Mode_Info_t modes[MAX_MODE_DD];
	int count_modes;
	int n_ptr_mode; //  
} Drv_D3D_Info_t;


extern Drv_DD_Info_t DDInfo[MAX_DRV_DD]; //   DD
extern Drv_D3D_Info_t D3DInfo[MAX_DRV_D3D];  //   D3D
extern int count_dd, count_d3d; //   DD, D3D
extern DEVMODE devmode; //   

	//   DD  7  

BOOL CheckDDVersion7();

	//      DD  D3D

BOOL EmumerateDriversD3D();

#endif

