//////////////////////////////////////////////////////////////////////////////////
// : 
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 06.2001
//////////////////////////////////////////////////////////////////////////////////
#include "rm.h"
#include "enumerate.h"
#include "scene.h"
#include <stdio.h>
#include <time.h>
#include <mmsystem.h>
#include <math.h>


LPDIRECT3DRMWRAP chrome_wrap=0;
LPDIRECT3DRMMESH chrome_mesh=0;

void __cdecl chrome_callback
	(LPDIRECT3DRMFRAME3 frame, LPVOID arg, D3DVALUE delta)
{
	LPDIRECT3DRMFRAME frame_tmp=0;

	frame->QueryInterface(IID_IDirect3DRMFrame, (LPVOID *)&frame_tmp);
    chrome_wrap->ApplyRelative( frame_tmp, (LPDIRECT3DRMOBJECT)chrome_mesh );
	DD_RELEASE( frame_tmp );
}


//   
BOOL DemoTexture()
{
    LPDIRECT3DRMFRAME3       frame=0;
    LPDIRECT3DRMMESHBUILDER3 builder=0;
	LPDIRECT3DRMMESH mesh=0;
	LPDIRECT3DRMTEXTURE3 texture=0;
    D3DRMBOX box;
    LPDIRECT3DRMWRAP wrap=0;
	D3DVALUE width, height;
	HRESULT rc;


	//  
	//  
	rc=rm_info.rm->LoadTexture("tree0.bmp",&texture);
	DD_CHK(rc,_gError);
	// 
	rc=rm_info.rm->CreateFrame( main_frame, &frame );
	DD_CHK(rc,_gError);
	// 
	frame->SetPosition( main_frame, -25.0f, 0.0f, 0.0f );
	//  
	rc=rm_info.rm->CreateMeshBuilder(&builder);
	DD_CHK(rc,_gError);
	// 
	build_cube_triangles(builder,DEGREES_90);
	// 
	builder->SetColor(RGBA_MAKE(32,255,32,200));
	// 
	ScaleMesh(builder,D3DVAL(15));

	//  
	//builder->SetTextureTopology(TRUE,TRUE);
	builder->SetTexture(texture);
    builder->GetBox( &box );
    width=box.max.x-box.min.x;
    height=box.max.y-box.min.y;
    rm_info.rm->CreateWrap(D3DRMWRAP_FLAT, rm_info.scene,
        D3DVAL(box.min.x), D3DVAL(box.min.y), D3DVAL(box.min.z),  //  
        D3DVAL(0), D3DVAL(0), D3DVAL(1),  // z  
        D3DVAL(0), D3DVAL(-1), D3DVAL(0), // y  
        D3DVAL(0), D3DVAL(0),               //  
        D3DDivide(1,width), D3DDivide(1,height),//  
        &wrap);
    wrap->Apply( builder );
    builder->SetPerspective(TRUE);

	//  
	builder->CreateMesh(&mesh);
	//   
	frame->AddVisual( (LPDIRECT3DRMVISUAL)mesh );
	DD_RELEASE( frame );
	DD_RELEASE( mesh );
	DD_RELEASE( builder );
	DD_RELEASE( texture );
    DD_RELEASE( wrap );


	//  
	//  
	rc=rm_info.rm->LoadTexture("env3.bmp",&texture);
	DD_CHK(rc,_gError);
	// 
	rc=rm_info.rm->CreateFrame( main_frame, &frame );
	DD_CHK(rc,_gError);
	// 
	frame->SetPosition( main_frame, 0.0f, 0.0f, 0.0f );
	rc=rm_info.rm->CreateMeshBuilder(&builder);
	DD_CHK(rc,_gError);
	//  
	build_cylinder(builder,20);
	// 
	ScaleMesh(builder,D3DVAL(15));

	frame->SetMaterialMode(D3DRMMATERIAL_FROMMESH);
	//  
	builder->SetTexture(texture);
    builder->GetBox( &box );
    height=box.max.y-box.min.y;
    rm_info.rm->CreateWrap(D3DRMWRAP_CYLINDER, rm_info.scene,
        D3DVAL(0), D3DVAL(box.min.y), D3DVAL(0),  //  
        D3DVAL(0), D3DVAL(-1), D3DVAL(0), // z  
        D3DVAL(0), D3DVAL(0), D3DVAL(-1),  // y  
        D3DVAL(0.5), D3DVAL(1),               //  
        D3DVAL(1), D3DDivide(1,height),//  
        &wrap);
    wrap->Apply( builder );
    builder->SetPerspective(TRUE);

	//  
	builder->CreateMesh(&mesh);
	//   
	frame->AddVisual( (LPDIRECT3DRMVISUAL)mesh );
	DD_RELEASE( frame );
	DD_RELEASE( mesh );
	DD_RELEASE( builder );
	DD_RELEASE( texture );
    DD_RELEASE( wrap );

	//  
	//  
	rc=rm_info.rm->LoadTexture("earth.bmp",&texture);
	DD_CHK(rc,_gError);
	// 
	rc=rm_info.rm->CreateFrame( main_frame, &frame );
	DD_CHK(rc,_gError);
	// 
	frame->SetPosition( main_frame, 25.0f, 0.0f, 0.0f );
	rc=rm_info.rm->CreateMeshBuilder(&builder);
	DD_CHK(rc,_gError);
	//  
	build_sphere(builder,20,20);
	//   
	// 
	ScaleMesh(builder,D3DVAL(15));

	//  
	builder->SetTexture(texture);
    rm_info.rm->CreateWrap(D3DRMWRAP_SPHERE, rm_info.scene,
        D3DVAL(0), D3DVAL(0), D3DVAL(0),  //  
        D3DVAL(0), D3DVAL(1), D3DVAL(0), // z  
        D3DVAL(0), D3DVAL(1), D3DVAL(0),  // y  
        D3DVAL(0), D3DVAL(0),               //  
        D3DVAL(1), D3DVAL(1),//  
        &wrap);
    wrap->Apply( builder );
    builder->SetPerspective(TRUE);

	//  
	builder->CreateMesh(&mesh);
	//   
	frame->AddVisual( (LPDIRECT3DRMVISUAL)mesh );
	DD_RELEASE( frame );
	DD_RELEASE( mesh );
	DD_RELEASE( builder );
    DD_RELEASE( wrap );

	//  
	//  
	rc=rm_info.rm->LoadTexture("chrome.bmp",&texture);
	DD_CHK(rc,_gError);
	// 
	rc=rm_info.rm->CreateFrame( main_frame, &frame );
	DD_CHK(rc,_gError);
	// 
	frame->SetPosition( main_frame, 0.0f, 0.0f, -50.0f );
	rc=rm_info.rm->CreateMeshBuilder(&builder);
	DD_CHK(rc,_gError);
	//  
	build_sphere(builder,20,20);
	// 
	builder->Scale(D3DVAL(25),D3DVAL(15),D3DVAL(0.1));
	//  
	builder->SetTexture(texture);
	//   
    builder->SetPerspective(TRUE);
	builder->SetQuality(D3DRMRENDER_GOURAUD&(~D3DRMLIGHT_ON)|(D3DRMLIGHT_OFF)); 
	//  
	DD_RELEASE( chrome_mesh );
	builder->CreateMesh(&chrome_mesh);

	DD_RELEASE( chrome_wrap );
    rm_info.rm->CreateWrap(D3DRMWRAP_CHROME, rm_info.camera,
        D3DVAL(0), D3DVAL(0), D3DVAL(0),  //  
        D3DVAL(0), D3DVAL(1), D3DVAL(0), // z  
        D3DVAL(0), D3DVAL(0), D3DVAL(-1),  // y  
        D3DVAL(0), D3DVAL(0),               //  
        D3DVAL(-1), D3DVAL(1),//  
        &chrome_wrap);
	frame->AddMoveCallback(chrome_callback, (LPVOID)NULL, D3DRMCALLBACK_PREORDER);

	//   
	frame->AddVisual( (LPDIRECT3DRMVISUAL)chrome_mesh );
	DD_RELEASE( frame );
	DD_RELEASE( builder );
	DD_RELEASE( texture );

    
_gError:
	DD_RELEASE( texture );
	DD_RELEASE( frame );
	DD_RELEASE( mesh );
    DD_RELEASE( wrap );
	DD_RELEASE( builder );
	DD_RELEASE( texture );
	return FALSE;
}
